

#include <liqbase/liqbase.h>
#include <liqbase/liqcell.h>
#include <liqbase/liqfont.h>
#include <liqbase/liqsketchfont.h>
#include <liqbase/liqcell_easyrun.h>
#include <liqbase/liqcell_easyhandler.h>
#include <liqbase/liqapp_prefs.h>
#include <liqbase/vgraph.h>
#include "liqdoc.h"

#include <X11/keysym.h>



#include "liqbookprogress.h"

//#####################################################################
//#####################################################################
//##################################################################### liqbookreader :: by gary birkett
//#####################################################################
//#####################################################################

	static int liqbookreader_paint_selfrotate(liqcell *self, liqcellpainteventargs *args,void *context)
{

		struct doc *doc = (struct doc *)liqcell_gettag(self);
		
		// the body contains the offset we need to render at
		// uber render, GOGOGO!
		liqcell *body = liqcell_child_lookup(self, "body");
		
		//if( -liqcell_gety(body) + liqcell_geth(body)   )
		//liqcell_setpos(body, liqcell_getx(body)-10,liqcell_getx(body) );
		liqcell_setpos(body, liqcell_getx(body),liqcell_gety(body)-1 );
		
		//doc.renderfont=font;
		//args->graph
		//int		vgraph_setfont(        			vgraph *self, liqfont *font);			//  char *fontname, int fontsize, int fontattributes
		//int		vgraph_setpencolor(    			vgraph *self, vcolor pencolor );
		//int		vgraph_drawtext(       			vgraph *self, int x, int y, char *text        );
		//vgraph_setfont(args->graph,      doc->renderfont);
		//vgraph_setpencolor( args->graph, vcolor_YUV(255,128,128) );
		
		
		
		

		static liqimage *img = NULL;
		if(img==NULL) img = liqimage_newatsize(480,800,0);
		
		liqcliprect *cr = liqcliprect_newfromimage(img);
		//liqcliprect_drawtext(cr,doc->displayfont,0,y,dline->linedata);
		
		//xsurface_drawrectwash_uv(img,0,0,480,800,128,128);
		liqcliprect_drawclear(cr,0,128,128);
		
		struct docline *dline = doc->linefirst;
		int y=0;
		int h=0;
		int vt = -liqcell_getx(body);
		int vb = vt + liqcell_getw(self);
		int tmp=0;
		while(dline)
		{
			h=dline->formath;
			//liqapp_log("huh %d %d,  vt=%d vb=%d",y,h,vt,vb);
			if(y+h > vt)
			{
				//liqapp_log("tmp %d",tmp);
				//vgraph_drawtext(args->graph, y-vt, 0,dline->linedata  );
				liqcliprect_drawtext(cr,doc->renderfont,0,y-vt,dline->linedata);
				//liqcliprect_drawtext_color(cr,doc->renderfont,0,y-vt,dline->linedata,rand()%128,rand()%255,rand()%255);
				if(y>vb) break;
			}
			tmp++;
			
			y+=h;
			dline=dline->linknext;
		}
		
		
		liqimage_rotate( liqcanvas_getsurface(), img, 90 );
		
		
		liqcliprect_release(cr);		
		//liqimage_release(img);
		
		
		
		//liqcell_setdirty(self,1);
		return 1;
	}






	static int liqbookreader_paint(liqcell *self, liqcellpainteventargs *args, void *context)
{

		struct doc *doc = (struct doc *)liqcell_gettag(self);
		
		// the body contains the offset we need to render at
		// uber render, GOGOGO!
		liqcell *body = liqcell_child_lookup(self, "body");
		
		
		// find out if orientation flipped.
		if( canvas.pixelwidth != liqcell_getw(body) )
		{
			// something changed, a glitch in the matrix.
			char *bookfilename = liqcell_propgets(self,"book_filename",NULL);
			unsigned int sfl = body->h;
			unsigned int sfu = -body->y;
			liqapp_log("book dynamic relayout, sfu=%d, sfl=%d",sfu,sfl);
			liqbookprogress_finishedreading_storeposition(bookfilename,sfl,sfu);
			liqcell_handlerrun(self,"layout",NULL);
			liqcell_setdirty(self,1);
			return 0;
			
		}
		
		
		
		//if( -liqcell_gety(body) + liqcell_geth(body)   )
		
		//liqcell_setpos(body, liqcell_getx(body)-10,liqcell_getx(body) );
		
		
		if(liqcell_propgeti(self,"autoscroll_inuse",0)==1)
		{
			liqcell_setpos(body, liqcell_getx(body),liqcell_gety(body)-1 );
			liqcell_setdirty(self,1);
		}
		
		
		//doc.renderfont=font;
		//args->graph
		//int		vgraph_setfont(        			vgraph *self, liqfont *font);			//  char *fontname, int fontsize, int fontattributes
		//int		vgraph_setpencolor(    			vgraph *self, vcolor pencolor );
		//int		vgraph_drawtext(       			vgraph *self, int x, int y, char *text        );
		liqfont_setview(doc->renderfont, 1,1);
		vgraph_setfont(args->graph,      doc->renderfont);
		vgraph_setpencolor( args->graph, vcolor_YUV(255,128,128) );
		struct docline *dline = doc->linefirst;
		int y=0;
		int h=0;
		int vt = -liqcell_gety(body);
		int vb = vt + liqcell_geth(self);
		int tmp=0;
		while(dline)
		{
			h=dline->formath;
			liqapp_log("huh %d %d,  vt=%d vb=%d",y,h,vt,vb);
			if(y+h > vt)
			{
				//liqapp_log("tmp %d",tmp);
				vgraph_drawtext(args->graph, 0,y-vt,dline->linedata  );
				if(y>vb) break;
			}
			tmp++;
			
			y+=h;
			dline=dline->linknext;
		}
		
		//
		return 1;
	}










int liqbookreader_getbookfontsize()
{
		int edfontsize;
		char * t=NULL;
		if((t=liqapp_pref_getvalue("book_fontsize")) && (*t) && (isdigit(*t)))
		{
			edfontsize=atoi(t);
			liqapp_log("liqbookreader_getbookfontsize arg fontsize = %d, '%s'",edfontsize,t);
		}
		else
		{
			edfontsize=40;
			liqapp_log("liqbookreader_getbookfontsize def fontsize = %d",edfontsize);
		}
		if(edfontsize<8)edfontsize=8;
		if(edfontsize>144)edfontsize=144;
		liqapp_log("liqbookreader_getbookfontsize act fontsize = %d",edfontsize);
		return edfontsize;
}


int liqbookreader_saveaspng(liqcell *self)
{
	struct doc *doc = (struct doc *)liqcell_gettag(self);
	liqcell *body = liqcell_child_lookup(self, "body");
	
	char *book_filename = liqcell_propgets(self,"book_filename",NULL);
	
	int font_height = liqfont_textheight(doc->renderfont);

	int scr_height = self->h;
	int book_linecount=doc->linecount;
	int book_totalheight=body->h;
	
	int page_topstart=-body->y;
	int page_lineviewcount=self->h/font_height;
	int page_topmax=book_totalheight-canvas.pixelheight;
	
	
	int page_width = canvas.pixelwidth;
	int page_height = book_totalheight;	
	
    liqcell_hold(self);

        liqapp_log("liqbookreader_saveaspng creating image");
        liqimage *img = liqimage_newatsize(page_width,page_height,0);
        if(!img)
        {
            liqapp_log("liqbookreader_saveaspng could not alloc image");
            liqcell_release(self);
            return -1;
        }
        
        liqapp_log("liqbookreader_saveaspng creating cliprect");
        liqcliprect *cr = liqcliprect_newfromimage(img);
        if(!cr)
        {
            liqapp_log("liqbookreader_saveaspng could not alloc cr");
            
            liqimage_release(img);
            liqcell_release(self);
            return -1;
        }


		char indexfilename[FILENAME_MAX]={0};
		FILE *indexfile;
		snprintf(indexfilename,sizeof(indexfilename),"%s.LiqBook.html",book_filename);
		indexfile=fopen(indexfilename,"w");
		if(!indexfile)
		{
            liqapp_log("liqbookreader_saveaspng could not open indexfile");
            
            liqimage_release(img);
            liqcell_release(self);
            return -1;
		}
		
		liqapp_log("liqbookreader_saveaspng setting up index");

		fprintf(indexfile,"<HTML>\n");
		fprintf(indexfile," <HEAD>\n");
		fprintf(indexfile," <TITLE>LiqBook '%s' by Gary Birkett.</TITLE>\n", liqapp_filename_walkoverpath(book_filename) );
		fprintf(indexfile," </HEAD>\n");
		fprintf(indexfile," <BODY bgcolor=\"#000000\" text=\"#ffffff\">\n");

		
		// Now, cycle the pages
		
		self->h = body->h;
		body->y = 0;
		
		int lineupto = 0;
		int pagenumber=0;

		
		char pagefilename[FILENAME_MAX]={0};
		//for(lineupto = 0; lineupto < book_linecount; lineupto+=page_lineviewcount )
		{
			body->y = -(font_height * page_lineviewcount) * pagenumber;
			
			
			snprintf(pagefilename,sizeof(pagefilename),"%s.page.%03d.png",book_filename,pagenumber);
    
			fprintf(indexfile," <img src='%s' width='%d' height='%d'></img><BR/>\n",liqapp_filename_walkoverpath(pagefilename), page_width,page_height);
			liqapp_log("liqbookreader_saveaspng clearing before cell %s",pagefilename);
			liqcliprect_drawclear(cr,0,128,128);
			
			liqapp_log("liqbookreader_saveaspng painting cell %s",pagefilename);
			liqcell_easypaint(self,cr,0,0,page_width,page_height);
			liqapp_log("liqbookreader_saveaspng saving image as '%s'",pagefilename);
			liqimage_pagesavepng(img,pagefilename);
			
			pagenumber++;
		}
		
		



		fprintf(indexfile," <A href='http://liqbase.net'>\n");
		fprintf(indexfile,"  <P>Created by Gary Birkett,</P>\n");
		fprintf(indexfile,"  <P>Smile Architect.</P>\n");
		fprintf(indexfile," </A>\n");
		fprintf(indexfile," </BODY>\n");
		fprintf(indexfile,"<HTML>\n");
		fclose(indexfile);
	


    
        
        liqapp_log("liqbookreader_saveaspng releasing cr");
        liqcliprect_release(cr);
        
        liqapp_log("liqbookreader_saveaspng releasing image");
        liqimage_release(img);
	
	liqapp_log("liqbookreader_saveaspng done");
    
	
	body->y = page_topstart;
	self->h = scr_height;
	
    liqcell_release(self);
}


/**	
 * liqbookreader keypress - the user pressed a key
 */	
static int liqbookreader_keypress(liqcell *self, liqcellkeyeventargs *args,void *context)
{

		struct doc *doc = (struct doc *)liqcell_gettag(self);
	liqcell *body = liqcell_child_lookup(self, "body");
	
	int font_height = liqfont_textheight(doc->renderfont);
	
	int book_linecount=doc->linecount;
	int book_totalheight=body->h;
	
	int page_topstart=-body->y;
	int page_lineviewcount=self->h/font_height;
	int page_topmax=book_totalheight-canvas.pixelheight;
	
	
	if(args->keycode==113)		// q
	{
		liqapp_pref_setvalue_printf( "book_fontsize", "%i", liqbookreader_getbookfontsize()-2 );
		liqapp_prefs_save();
		liqcell_handlerrun(self,"layout",NULL);
		// smaller font
	}
	else
	if(args->keycode==115)		// s
	{
		// saving book as png.
		// allocate "page"
		// render to it.
		
		liqbookreader_saveaspng(self);
		
		//liqapp_pref_setvalue_printf( "book_fontsize", "%i", liqbookreader_getbookfontsize()-2 );
		//liqapp_prefs_save();
		//liqcell_handlerrun(self,"layout",NULL);
		// smaller font
	}
	else
	if(args->keycode==119)		// w
	{
		
		liqapp_pref_setvalue_printf( "book_fontsize", "%i", liqbookreader_getbookfontsize()+2 );
		liqapp_prefs_save();
		liqcell_handlerrun(self,"layout",NULL);
		// bigger font
	}
	else
	if(args->keycode==XK_Left || args->keycode==XK_Down)
	{
		// move back a page
		page_topstart = (((page_topstart - self->h)/ font_height)+1)*font_height;
		if(page_topstart<0)page_topstart=0;
		liqcell_setpos(body, liqcell_getx(body), -page_topstart );
		liqcell_setdirty(self,1);
	}
	else
	if(args->keycode==XK_Right || args->keycode==XK_Up)
	{
		// move forward a page
		page_topstart = (((page_topstart + self->h)/ font_height))*font_height;
		if(page_topstart>page_topmax)page_topstart=page_topmax;
		liqcell_setpos(body, liqcell_getx(body), -page_topstart );
		liqcell_setdirty(self,1);
	}
	else
	if(args->keycode==32)
	{
		// autoscroll..
		if(liqcell_propgeti(self,"autoscroll_inuse",0)==1)
		{
			// its in use, need to disable it
			liqcell_propseti(self,"autoscroll_inuse",0);
		}
		else
		{
			// not in use, need to enable it
			liqcell_propseti(self,"autoscroll_inuse",1);
		}
	}
	else
	{
		liqapp_log("liqbookreader: Unknown keycode %d",args->keycode);
	}
	return 0;
}
/**	
 * liqbookreader keyrelease - the user released a key
 */	
static int liqbookreader_keyrelease(liqcell *self, liqcellkeyeventargs *args,void *context)
{

		struct doc *doc = (struct doc *)liqcell_gettag(self);
	return 0;
}




/**	
 * liqbookreader layout - rebuild book details
 */	
static int liqbookreader_layout(liqcell *self, liqcelleventargs *args,void *context)
{

		struct doc *doc = (struct doc *)liqcell_gettag(self);

		liqcell_setrect(self, 0,0, canvas.pixelwidth,canvas.pixelheight);

		
		liqcell *body = liqcell_child_lookup(self, "body");
		
	
		int err=0;
		
		char *bookfilename = liqcell_propgets(self,"book_filename",NULL);
		
		//================================================== get and process the fontsize
		int edfontsize=liqbookreader_getbookfontsize();
		liqapp_log("liqbookreader_run act fontsize = %d",edfontsize);
		
		//=================================================== now, open the font
		
		liqfont *font = liqfont_newfromfilettf("/usr/share/fonts/nokia/nosnb.ttf", (edfontsize), 0);


		if(!font)
		{
			{ return liqapp_warnandcontinue(-1,"liqbookreader_layout couldnt open font"); }						
		}
		
		//liqfont_setscale(font,1,1);


		liqfont_setview(font, 1,1);

		//=================================================== initialize the bookprogress

		liqbookprogress_shutdown();
		liqbookprogress_startup();


		if(doc->renderfont)
		{
			liqfont_release(doc->renderfont);
			doc->renderfont=NULL;
		}
		
		doc->renderfont=font;
		doc->rendermarginright=canvas.pixelwidth;
		//doc.rendermarginbottom=99999999;
	
		err=doc_initfromfilename(doc,bookfilename);
		
		
		if(err)
		{
			{ return liqapp_warnandcontinue(-1,"liqbookreader_layout couldnt open doc"); }						
		}



		liqcell_setrect(self, 0,0, canvas.pixelwidth,canvas.pixelheight);
		liqcell_setrect(body, 0,0, canvas.pixelwidth,doc->rendertoth);
		
		unsigned int sfl=0;
		unsigned int sfu=0;
		if(liqbookprogress_startreading_lookupposition(bookfilename,&sfl,&sfu))
		{
			//
			if(sfu>sfl-(self->h))sfu=sfl-self->h;
			liqapp_log("book layout, sfu=%d, sfl=%d",sfu,sfl);
			if(body->h>0 && sfl>0)
				liqcell_setpos(body,0, -( sfu * (body->h/128) / (sfl/128)));
				
			liqapp_log("book layout, body->y=%d, body->h=%d",body->y,body->h);
				
		}
		
		
			

	return 0;

}







int liqbookreader_run(char *bookfilename)
{
	liqcell *self = liqcell_quickcreatewidget("liqbookreader","form", canvas.pixelwidth,canvas.pixelheight);

	if(self)
	{

		liqcell_propsets(self,"book_filename",bookfilename);
		//char *bookfilename = liqcell_propgets(self,"book_filename",NULL);


		int err=0;
		
		//char *bookfilename = liqcell_propgets(self,"bookfilename",NULL);
	


		liqcell *body = liqcell_quickcreatevis("body",NULL,0 ,0, canvas.pixelwidth,canvas.pixelheight  );
		liqcell_handleradd(body,    "mouse",   liqcell_easyhandler_kinetic_mouse );
		liqcell_child_insert( self, body );
		


		// create base doc structure
		struct doc doc;
		doc.renderfont=NULL;
		
		
		// link them badly, this should be a tag*
		liqcell_settag(self,(int)&doc);
		
		
		//liqcell_handleradd_withcontext(body,    "paint", widget_paint,self);
		
		//########################################## custom renderer ..
		
		liqcell_handleradd_withcontext(self, "layout",     (void*)liqbookreader_layout,     NULL);
		liqcell_handleradd_withcontext(self, "paint",      (void*)liqbookreader_paint,      NULL);
		liqcell_handleradd_withcontext(self, "keypress",   (void*)liqbookreader_keypress,   NULL);
		liqcell_handleradd_withcontext(self, "keyrelease", (void*)liqbookreader_keyrelease, NULL);
		
		liqcell_handlerrun(self,"layout",NULL);
		
		liqcell_easyrun(self);
		
		
		unsigned int sfl = body->h;
		unsigned int sfu = -body->y;
		liqapp_log("book closing, sfu=%d, sfl=%d",sfu,sfl);
		liqbookprogress_finishedreading_storeposition(bookfilename,sfl,sfu);
	}
	
	
	liqcell_release(self);
	return 0;
	//return self;
}
